-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                       
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 1999,2007 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/procs/hist_busavailability.sql, tbsm_base211, tbsm_base31e
-- SID: 1.9
-- Date Modified: 07/11/20 07:27:53
--
-- Module Description:
--   PROCEDURE FOR Business System Availability report.
-- 
--  exec hist_busavailability 'LOB',3,'1,3','2003-04-09 14:39:00','2003-04-09 15:00:00',0
--  exec hist_busavailability 'LOB',3,'','2003-04-09 14:39:00','2003-04-09 15:00:00',1
--  select * from AlertStateHistory WHERE cid = 'LOB' and id = 3
-- Update AlertStateHistory set AlertStateID = 2 WHERE ctime = CAST('2003-04-09 14:39:08.640' AS DATETIME) and cid = 'LOB' and id = 3

USE Object
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'hist_busavailability' AND type = 'P')
  DROP PROCEDURE hist_busavailability
GO

PRINT 'Creating procedure hist_busavailability...'
GO
-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                       
--                                                                   
-- 5724-C51                                                          
--                                                                   
-- (C) Copyright IBM Corp. 2004 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}


-- File: archive/db/sql/procs/hist_busavailability.sql, tbsm_base211, tbsm_base31e
-- SID: 1.9
-- Date Modified: 07/11/20 07:27:53
--
-- Module Description:
--   PROCEDURE FOR event COUNT reports
-- History of Changes:
--   OW57191 - LOB REPORTS TIMEOUT FROM REPORTING SYSTEM
-- 
--  exec hist_busavailability 'LOB',3,'1,3','2003-04-09 14:39:00','2003-04-09 15:00:00',0
--  exec hist_busavailability 'LOB',3,'','2003-04-09 14:39:00','2003-04-09 15:00:00',1
--  select * from AlertStateHistory WHERE cid = 'LOB' and id = 3
-- Update AlertStateHistory set AlertStateID = 2 WHERE ctime = CAST('2003-04-09 14:39:08.640' AS DATETIME) and cid = 'LOB' and id = 3


CREATE PROCEDURE hist_busavailability
  @cid ClassID,
  @id ObjID,
  @alertstates NVARCHAR(255),
  @begtime NVARCHAR(30),
  @endtime NVARCHAR(30),
  @includechild INT=0,
  @orderopt INT=2
AS

--Object id 0 indicates all of class
CREATE TABLE #alertstatehistory(
  ident           INTEGER IDENTITY(1,1),
  cid             ClassID,
  id              ObjID,
  ctime           datetime,
  as_to           DATETIME NULL,
  alert_state     INTEGER,
  as_total_time   INTEGER,
  as_hours        INTEGER,
  as_minutes      INTEGER,
  as_seconds      INTEGER,
  ev_cid          ClassID,
  ev_id           ObjID,
  ev_oldalertstate INTEGER,
  ev_ctime        datetime, 
  ev_detail       NVARCHAR(510)   
)

CREATE TABLE #finalalertstatehistory(
  ident           INTEGER IDENTITY(1,1),
  cid             ClassID,
  id              ObjID,
  path            NVARCHAR(255),
  ctime           datetime,
  as_to           DATETIME NULL,
  alert_state     INTEGER,
  as_total_time   INTEGER,
  as_hours        INTEGER,
  as_minutes      INTEGER,
  as_seconds      INTEGER,
  ev_cid          ClassID,
  ev_id           ObjID,
  ev_oldalertstate INTEGER,
  ev_ctime        datetime, 
  ev_detail       NVARCHAR(255)  
)

SET NOCOUNT ON

IF @id<>0
BEGIN
  CREATE TABLE #objtemp (cid ClassID, id ObjID, name ObjName NULL)
  IF @cid='LOB'
  BEGIN
    --INSERT INTO #objtemp( cid,id,name ) SELECT @cid,@id,''
    -- EXEC report_lob_objects @id, @includechild  Becky commented out
    --- Becky Question???? does @includechild mean the same as includeleafchild->see report_lob_objects
    IF @includechild=1 EXEC report_lob_objects @id, @includechild
  END
  ELSE
  BEGIN
    IF @includechild=1
      EXEC report_phys_objects @cid, @id
    ELSE
      INSERT #objtemp SELECT @cid, @id, NULL
  END
  EXEC report_addclassdata '#objtemp', 'name', 'name' --Becky uncommented out
  --SELECT @tablelist='#objtemp o,', @whereclause1='e.obj_cid=o.cid AND e.obj_id=o.id'
  --SELECT @objclassjoin=' AND obj.cid=o.cid'
END

-- Debug
--DELETE #objtemp
--INSERT INTO #objtemp( cid,id,name ) SELECT @cid,@id,''

-- Debug.
--PRINT 'Contents of #objtemp'
--SELECT * FROM #objtemp

/*
INSERT INTO #alertstatehistory (cid,id, ctime, as_to, alert_state, as_total_time, as_hours, as_minutes, as_seconds)
SELECT ah.cid, ah.id, ah.ctime, NULL, ah.AlertStateID,0,0,0,0 
FROM AlertStateHistory ah 
JOIN #objtemp o ON o.cid = ah.cid and o.id = ah.id
AND ctime >= CAST(@begtime AS DATETIME)
AND ctime <= CAST(@endtime AS DATETIME)
*/

DECLARE c_objtemp CURSOR FOR SELECT DISTINCT cid,id FROM #objtemp
OPEN c_objtemp
FETCH NEXT FROM c_objtemp INTO @cid, @id

-- For each cid,id get it's set of alertstate rows and process them.
WHILE @@FETCH_STATUS = 0
BEGIN

  IF EXISTS (SELECT * FROM AlertStateHistory ah WHERE ah.cid = @cid and ah.id = @id
             AND ctime >= CAST(@begtime AS DATETIME)
             AND ctime <= CAST(@endtime AS DATETIME) )
  BEGIN

  -- Get a cid,id row set to work on.
  INSERT INTO #alertstatehistory (cid,id, ctime, as_to, alert_state, as_total_time, as_hours, as_minutes, as_seconds,ev_cid, ev_id, ev_oldalertstate, ev_ctime, ev_detail)
  SELECT ah.cid, ah.id, ah.ctime, NULL, ah.AlertStateID,0,0,0,0,ah.evt_cid, ah.evt_id, ah.OldAlertStateID, ah.evt_ctime,ah.evt_detail 
  FROM AlertStateHistory ah 
  WHERE ah.cid = @cid and ah.id = @id
  AND ctime >= CAST(@begtime AS DATETIME)
  AND ctime <= CAST(@endtime AS DATETIME)
  ORDER BY ctime

  --PRINT 'Row set for ' + @cid +','+CAST(@id AS VARCHAR(9))
  --SELECT * FROM #alertstatehistory

  -- A span row is a row that will be added to a cid,id row set when there is a 
  -- a time period that needs to be filled in at the beginning of the time range.
  -- Ex.) If the time range passed in is from 1:00pm to 2:00pm and the first alertstate change
  --      within that set occured at 1:15 then a new row with a start time of 1:00pm and a endtime
  --      of 1:15 is added to the set. The alertstate for this added record is the alertstate of the 
  --      row just prior to 1:00pm.
  -- 
  -- Use this cursor to see if there is a need for a span row.
  /*
  DECLARE c_as_span CURSOR FOR SELECT DISTINCT cid,id FROM #alertstatehistory 
  OPEN c_as_span
  FETCH NEXT FROM c_as_span INTO @cid, @id

  WHILE @@FETCH_STATUS = 0
  BEGIN
  */
    IF EXISTS( SELECT * FROM #alertstatehistory WHERE ctime > CAST(@begtime AS DATETIME) and cid = @cid and id = @id )
      AND NOT EXISTS(SELECT * FROM #alertstatehistory WHERE ctime = CAST(@begtime AS DATETIME) and cid = @cid and id = @id )
    BEGIN
	
      --PRINT 'MAY NEED SPAN ROW'
      DECLARE @span_to DATETIME
      DECLARE @span_ev_cid ClassID
      DECLARE @span_ev_id ObjID
      DECLARE @span_ev_oldalertstate INTEGER
      DECLARE @span_ev_ctime DATETIME
      DECLARE @span_ev_detail NVARCHAR(510) 
      DECLARE @min_ctime DATETIME

      DECLARE @span_alertstate INT
      DECLARE @max_ctime DATETIME

      SELECT @max_ctime = NULL
      SELECT @span_alertstate = NULL

      -- Isolate the first row of the set to use it's ctime value as the ending ctime value of the span row.
      SELECT @span_to = MIN(ctime) FROM #alertstatehistory 
      WHERE ctime > CAST(@begtime AS DATETIME) and cid = @cid and id = @id
      --SELECT @span_to
	
      -- find the first row outside the from date/time and get it's alertstate if it exists.
      IF EXISTS( SELECT * FROM AlertStateHistory WHERE ctime < CAST(@begtime AS DATETIME) and cid = @cid and id = @id )
      BEGIN
        SELECT @max_ctime = ctime FROM AlertStateHistory WHERE ctime < CAST(@begtime AS DATETIME) and cid = @cid and id = @id 
        IF @max_ctime IS NOT NULL
        BEGIN
          --PRINT 'span alertsate'
          SELECT @span_alertstate = AlertStateID,@span_ev_cid = evt_cid,@span_ev_id = evt_id, @span_ev_oldalertstate = OldAlertStateID, @span_ev_ctime = evt_ctime, @span_ev_detail = evt_detail FROM AlertStateHistory 
	  WHERE ctime = @max_ctime and cid = @cid and id = @id
	  --SELECT @span_alertstate
	END
      END
	  
    END

/*
    FETCH NEXT FROM c_as_span INTO @cid, @id

  END
  DEALLOCATE c_as_span
*/

  DECLARE @ctime DATETIME
  DECLARE @curr_ident INTEGER
  DECLARE @prev_ident INTEGER
  DECLARE @as_to DATETIME

  DECLARE c_as_history CURSOR FOR SELECT ident,ctime,as_to FROM #alertstatehistory ORDER BY cid,id
  OPEN c_as_history
  FETCH NEXT FROM c_as_history INTO @curr_ident, @ctime, @as_to

  SET @prev_ident = @curr_ident

  WHILE @@FETCH_STATUS = 0
  BEGIN
    
    FETCH NEXT FROM c_as_history INTO @curr_ident, @ctime, @as_to
  
    --print 'previous ident := ' + CAST(@prev_ident AS VARCHAR(9))
    --print 'event time     := ' + CAST(@ctime AS VARCHAR(30))
    IF @as_to IS NULL
      UPDATE #alertstatehistory SET as_to = @ctime WHERE ident = @prev_ident

    SET @prev_ident = @curr_ident
  
  END

  DEALLOCATE c_as_history

  UPDATE #alertstatehistory SET as_to = CAST(@endtime AS DATETIME) WHERE ident = @curr_ident
  UPDATE #alertstatehistory SET as_total_time = DATEDIFF(ss,ctime, as_to) 

  IF @span_to IS NOT NULL and @span_alertstate IS NOT NULL 
  BEGIN
    --PRINT 'Creating span row.'
    INSERT INTO #alertstatehistory (cid,id, ctime, as_to, alert_state, as_total_time, as_hours, as_minutes, as_seconds,ev_cid, ev_id, ev_oldalertstate,ev_ctime,ev_detail)
      SELECT @cid, @id,CAST(@begtime AS DATETIME), @span_to, @span_alertstate,DATEDIFF(ss,CAST(@begtime AS DATETIME), @span_to),0,0,0,@span_ev_cid,@span_ev_id,@span_ev_oldalertstate,CAST(@span_ev_ctime AS DATETIME),@span_ev_detail
  END

  SET @span_to = NULL
  SET @span_alertstate = NULL
  declare @tot_seconds integer
  declare @seconds integer
  declare @hours integer
  declare @minutes integer
  declare @ident integer
  declare @as_total_time VARCHAR(255)

  DECLARE c_as_history2 CURSOR FOR SELECT ident,as_total_time FROM #alertstatehistory 
  OPEN c_as_history2
  FETCH NEXT FROM c_as_history2 INTO @ident,@tot_seconds

  WHILE @@FETCH_STATUS = 0
  BEGIN

    set @hours = @tot_seconds / ( 60 * 60 )
    set @tot_seconds = @tot_seconds - ( @hours * 60 * 60 )
    set @minutes = @tot_seconds / ( 60 )
    set @tot_seconds = @tot_seconds - ( @minutes * 60 )
    set @seconds = @tot_seconds

    --SET @as_total_time = CAST(@hours AS VARCHAR(10)) + ' hrs. ' + CAST(@minutes AS VARCHAR(10)) + ' mins. ' + CAST(@seconds AS VARCHAR(10)) + ' secs.'
    UPDATE #alertstatehistory SET as_hours = @hours, as_minutes = @minutes, as_seconds = @seconds WHERE ident = @ident

    FETCH NEXT FROM c_as_history2 INTO @ident,@tot_seconds
  
  END

  DEALLOCATE c_as_history2

  -- Add cid,id set to final return table.
  INSERT INTO #finalalertstatehistory (cid,id, path, ctime, as_to, alert_state, as_total_time, as_hours, as_minutes, as_seconds, ev_cid, ev_id,ev_oldalertstate,ev_ctime,ev_detail)
    SELECT cid,id,'', ctime, as_to, alert_state, as_total_time, as_hours, as_minutes, as_seconds,ev_cid, ev_id,ev_oldalertstate, ev_ctime, ev_detail FROM #alertstatehistory

  DELETE #alertstatehistory

  END
  
  FETCH NEXT FROM c_objtemp INTO @cid, @id

END
DEALLOCATE c_objtemp

DECLARE @sql NVARCHAR(2000)

-- Update the resource path from ObjPathCache.
UPDATE #finalalertstatehistory SET path = pc.resourcepath
 FROM #finalalertstatehistory fh 
 JOIN ObjPathCache pc ON pc.cid = fh.cid and pc.id = fh.id

UPDATE #finalalertstatehistory SET path = LTRIM(RTRIM(REPLACE(path,'BUSC/','')))
UPDATE #finalalertstatehistory SET path = LTRIM(RTRIM(REPLACE(path,'LOBC/','')))

-- Filter alertstates before final Join.
IF @alertstates IS NOT NULL AND @alertstates <> ''
BEGIN
  SET @sql = 'DELETE FROM #finalalertstatehistory WHERE alert_state NOT IN(' + @alertstates + ')'
  EXEC(@sql)
END


SET @sql = 'SELECT o.name,path AS ''path'',ast.name AS ''alertstate'',ah.ctime AS ''periodstart'', ah.as_to AS ''periodend'', ah.as_total_time as ''totaltime'', ah.as_hours as ''hours'', ah.as_minutes AS ''minutes'', ah.as_seconds AS ''seconds'',ah.ev_cid AS ''eventCID'',ah.ev_id AS ''eventID'',alst.name AS ''oldalertstate'',ah.ev_ctime AS ''EventCreateTime'',ah.ev_detail AS ''EventDetail''
 FROM #finalalertstatehistory ah
 JOIN #objtemp o ON o.id = ah.id AND o.cid = ah.cid
 JOIN AlertState_V alst ON alst.id= ah.ev_oldalertstate
 JOIN AlertState_V ast ON ast.id = ah.alert_state'

IF @orderopt = 2
BEGIN
  SET @sql = @sql + ' ORDER BY o.name, ah.ctime'
END
ELSE
  BEGIN
     SET @sql = @sql + ' ORDER BY ah.ctime'
  END


--PRINT @sql

EXEC(@sql)

SET NOCOUNT OFF
