-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                       
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 2006 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/tracks/oa23441_clean.sql, tbsm_base, tbsm_base31e
-- SID: 1.1
-- Date Modified: 07/12/19 08:54:29
--
-- Module Description
--  Fix the exception names in ExceptionType_C_BASE
-----------------------------------------------------------------------------------------

USE Object
go

SET NOCOUNT ON
go

DECLARE @id INT
DECLARE @cid ClassID
DECLARE @excp NVARCHAR(255)
DECLARE @name ObjName
DECLARE @msg NVARCHAR(1024)

SELECT @id = 0

WHILE EXISTS ( SELECT * from ExceptionType_C_BASE WHERE name LIKE '%[_]EXCT0[0-9][0-9][_]%' AND id > @id AND deleted = 0 )
BEGIN
  SELECT @id = min(id) FROM ExceptionType_C_BASE WHERE name LIKE '%[_]EXCT0[0-9][0-9][_]%' AND id > @id AND deleted = 0
  SELECT @name = name FROM ExceptionType_C_BASE WHERE id = @id

  SELECT @cid = ltrim(rtrim(substring (@name,0,charindex('_',@name))))
  SELECT @excp = ltrim(rtrim(substring (@name,charindex('_',@name,charindex('_',@name)+1)+1,len(@name))))

  IF EXISTS ( SELECT 1 FROM ExceptionType_T_BASE WHERE cid = @cid AND Exception = @excp )
  BEGIN
    SELECT @msg = 'Updating name in ExceptionType_C_BASE from ' + @name + ' to ' + @cid + '_' + @excp + '.'
    RAISERROR ('%s',0,1,@msg) WITH NOWAIT
    UPDATE ExceptionType_C_BASE SET name = @cid + '_' + @excp WHERE id =@id
  END
END

go
